
unit GsMemoReg;

interface

uses
  Classes;

procedure Register;

implementation

{$R GSMemoIDE.res}

uses
  Forms, SysUtils, Windows, StdCtrls, ExtCtrls, Graphics, Dialogs, DsgnIntf, ShellApi,
  GsMemo, GsMemoHTMLCode, GsRegExp;

{ TGsAboutProperty }

type
  TGsAboutProperty = class(TStringProperty)
  private
    procedure CreateDialog(CName: string);
    procedure ClickEvent(Sender: TObject);
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure TGsAboutProperty.ClickEvent(Sender: TObject);
var
  Lnk: String;
begin
  if Sender is TLabel then Lnk := TLabel(Sender).Caption;
  if Pos('http://', Lnk) <> 0 then
    ShellExecute(Application.Handle, nil, PChar(Lnk), nil, nil, SW_SHOWNORMAL)
  else
    ShellExecute(Application.Handle, nil, PChar('mailto:' + Lnk), nil, nil, SW_SHOWNORMAL);
end;

procedure TGsAboutProperty.CreateDialog(CName: string);
var
  DlgForm: TForm;
  MsgLabel, EmailLabel: TLabel;
  ClsButton: TButton;
  MsgImage: TImage;
  Ico1, Ico2: TBitmap;
  DR, SR: TRect;
  S: string;
begin
  S := 'About ' + CName + Chr(13) + 'Copyright  2000, Radu Buzea. All right reserved.' +
    Chr(13) + Chr(13) +
    'For redistribution and use in source and binary form, with or without modification, see the License Agreement text file (license.txt).' +
    Chr(13) + Chr(13) +
    'Visit TGsMemo Federation page on the Internet at:' +
    Chr(13) + Chr(13) + Chr(13) +
    'Send comments and bug reports by e-mail at:';
  Ico1 := TBitmap.Create;
  Ico2 := TBitmap.Create;
  Ico2.Canvas.Brush.Color := clBtnFace;
  try
    Ico1.LoadFromResourceName(hInstance, UpperCase(CName));
    DR := Rect(0, 0, Ico1.Width, Ico1.Height);
    SR := DR;
    Ico2.Width := Ico1.Width;
    Ico2.Height := Ico1.Height;
    Ico2.Canvas.BrushCopy(DR, Ico1, SR, clFuchsia);
  except
    Ico2.Width := 28;
    Ico2.Height := 28;
    DR := Rect(0, 0, 28, 28);
    Ico2.Canvas.FillRect(DR);
  end;
  DlgForm := TForm.CreateNew(Application);
  with DlgForm do
  try
    BorderStyle := bsDialog;
    Position := poScreenCenter;
    ClientWidth := 320;
    ClientHeight := 220;
    Scaled := False;
    Caption := 'About ' + CName;
    MsgImage := TImage.Create(DlgForm);
    MsgImage.Parent := DlgForm;
    MsgImage.Left := 12;
    MsgImage.Top := 12;
    MsgImage.Picture.Assign(Ico2);
    MsgImage.AutoSize := True;
    MsgLabel := TLabel.Create(DlgForm);
    MsgLabel.Parent := DlgForm;
    MsgLabel.AutoSize := False;
    MsgLabel.WordWrap := True;
    MsgLabel.SetBounds(24 + MsgImage.Width, MsgImage.Top + 1,
      ClientWidth - MsgImage.Width - 42, 200);
    MsgLabel.Caption := S;
    EmailLabel := TLabel.Create(DlgForm);
    EmailLabel.Parent := DlgForm;
    EmailLabel.Font.Color := clBlue;
    EmailLabel.Font.Style := [fsUnderline];
    EmailLabel.Left := 24 + MsgImage.Width;
    EmailLabel.Top := 155;
    EmailLabel.Caption := 'radu@rospotline.com';
    EmailLabel.Cursor := -21;
    EmailLabel.OnClick := ClickEvent;
    ClsButton := TButton.Create(DlgForm);
    ClsButton.Parent := DlgForm;
    ClsButton.Left := (ClientWidth - ClsButton.Width) div 2;
    ClsButton.Top := ClientHeight - ClsButton.Height - 10;
    ClsButton.Caption := 'Close';
    ClsButton.Cancel := True;
    ClsButton.Default := True;
    ClsButton.ModalResult := 1;
    ShowModal;
    ClsButton.Free;
    EmailLabel.Free;
    MsgImage.Free;
    MsgLabel.Free;
  finally
    DlgForm.Free;
  end;
  Ico1.Free;
  Ico2.Free;
end;

procedure TGsAboutProperty.Edit;
var
  CName: string;
begin
  CName := GetValue;
  Delete(CName, 1, 7);
  Delete(CName, Length(CName), 1);
  CreateDialog(CName);
end;

function TGsAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog, paReadOnly];
end;

{ Register Components and  Property Editors }

procedure Register;
begin
  RegisterComponents('GS Memo', [TGsMemo, TGsMemoHTMLCode, TGsMemoDTMLCode]);
  RegisterPropertyEditor(TypeInfo(TGsAbout), nil, '', TGsAboutProperty);
end;

end.

